package org.apidesign.apifest08.currency;

/**
 * Some Factory for Factories :-)
 * Depends on the whole application design...
 * @author Ladislav Vitasek
 */
final public class ConvertorsFactory {
    private CurrencyConvertorFactory currencyConvertorFactoryInstance = null;
    private final static ConvertorsFactory instance = new ConvertorsFactory();


    private ConvertorsFactory() {

    }

    public static CurrencyConvertorFactory getCurrencyConvertorFactoryInstance() throws CannotInstantiateFactoryException {
        return getInstance().getCurrencyConvertor();
    }

    /**
     * Returns instance of CurrencyConvertorFactory 
     * @return new instance of CurrencyConvertorFactory
     * @throws CannotInstantiateFactoryException
     */
    private synchronized CurrencyConvertorFactory getCurrencyConvertor() throws CannotInstantiateFactoryException {
        if (currencyConvertorFactoryInstance == null) {//intern implementation
//            String className = System.getProperty("currencyFactory", CurrencyConvertorFactoryImpl.class.getName());
//            try {
//                currencyConvertorFactoryInstance = (CurrencyConvertorFactory) Class.forName(className).newInstance();
//            } catch (Exception e) {
//                throw new CannotInstantiateFactoryException(e);
//            }
            //without reflection
            currencyConvertorFactoryInstance = new CurrencyConvertorFactoryImpl();
        }
        return currencyConvertorFactoryInstance;
    }

    public static ConvertorsFactory getInstance() {
        return instance;
    }
}
