package org.apidesign.apifest08.currency;

import java.util.Currency;

/**
 * Convertor Factory implementation
 * In the real-time world this code should be optimized - convertors caching etc.
 * @author Ladislav Vitasek
 */
class CurrencyConvertorFactoryImpl extends AbstractConvertorFactory  {
    

    CurrencyConvertorFactoryImpl() {
        super();
    }

    // Note - implementation of this method is dummy
    
    public Convertor createConvertor(Currency currency1, Currency currency2, ConversionProperties conversionProperties) throws ConvertorNotAvailableException {
        if (currency1 == null || currency2 == null || conversionProperties == null)
            throw new NullPointerException();

        try {
            return new CurrencyConvertorImpl(currency1, currency2, conversionProperties.getConversionRatioProvider(), conversionProperties.getRoundingMode());//can be cached somehow
        } catch (Exception e) {
            throw new ConvertorNotAvailableException(e);
        }
    }
}
